package it.unibo.ai.rec.ui;

import java.text.*;
import java.util.Date;

import it.unibo.ai.rec.common.TimeGranularity;
import it.unibo.ai.rec.model.HappenedEventSet;

public abstract class EventOutputter {
	protected TimeGranularity granularity;
	
	
	public EventOutputter(TimeGranularity granularity) {
		this.granularity = granularity;
	}
	
	public abstract String toString(HappenedEventSet set);

	public Date getTimestamp(long timestamp) {
		return new Date(timestamp*granularity.getFactor());
	}

	public TimeGranularity getGranularity() {
		return granularity;
	}

	public String getDescription(HappenedEventSet set) {
		StringBuffer b = new StringBuffer();
		for(String event: set.getEvents()) {
			b.append(outputEvent(event));
			b.append(",");
		}
		return b.substring(0, b.length()-1);
	}
	
/*	protected String outputEvent(String event) {
		return event;
	}*/
	
	protected String outputEvent(String event) {//exec(ev)
		if(event.startsWith("exec(") && event.endsWith(")"))
			return event.substring(5, event.length()-1);
		else
			return event;
	}
}
